require("guiLib/guiLib")

--------------
-- tmpScreen
tmpScreen = CreateScreen("confirmationScreen", ScreenConfig(screenSize))

-- Ask confirmation
function popupDialog(backScreen, dialogType, message, answerYesFn, answerNoFn)
	local btSize = texMenuBtNormal:GetSize()

	local tmpGroup = tmpScreen:CreateGroup("tmpGroup")
	local width = btSize.x * 2 + 20

	-- Background
	local tmp = tmpGroup:CreateScreenRenderer("gameRenderer")
	tmp:SetTargetScreen(backScreen)
	tmp:SetZpos(-5000)
	
	-- Text
	local tmp = tmpGroup:CreateText("message", message)
	tmp:SetColor(Color(255, 255, 255))
	tmp:SetSize(40)
	tmp:SetMaxWidth(width)
	local txtSize = tmp:GetTextSize()
	tmp:SetPosition(Vector2D(width / 2 - txtSize.x / 2, 0))
	
	
	-- Bts
	if dialogType == "dialogYesNo" then
		local bt = tmpGroup:CreateGroup("noBt")
		buttonControlCreate(bt, _("No"), btSize)
		buttonSetEventFunction(bt, function(group) group:GetUserData("answerFn")(); ChangeScreen(group:GetUserData("backScreen")); group:GetParent():Destroy(); end)
		buttonSetFont(bt, 34, Color(0, 0, 0))
		buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
		bt:SetPosition(Vector2D(0, txtSize.y + 20))
		bt:SetUserData("answerFn", answerNoFn)
		bt:SetUserData("backScreen", backScreen)
		
		local bt = tmpGroup:CreateGroup("yesBt")
		buttonControlCreate(bt, _("Yes"), btSize)
		buttonSetEventFunction(bt, function(group) group:GetUserData("answerFn")(); ChangeScreen(group:GetUserData("backScreen")); group:GetParent():Destroy(); end)
		buttonSetFont(bt, 34, Color(0, 0, 0))
		buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
		bt:SetPosition(Vector2D(width - btSize.x, txtSize.y + 20))
		bt:SetUserData("answerFn", answerYesFn)
		bt:SetUserData("backScreen", backScreen)
	elseif dialogType == "dialogOk" then
		local bt = tmpGroup:CreateGroup("okBt")
		buttonControlCreate(bt, _("Ok"), btSize)
		buttonSetEventFunction(bt, function(group) group:GetUserData("answerFn")(); ChangeScreen(group:GetUserData("backScreen")); group:GetParent():Destroy(); end)
		buttonSetFont(bt, 34, Color(0, 0, 0))
		buttonSetImagePack(bt, texMenuBtNormal, texMenuBtOver, texMenuBtPressed)
		bt:SetPosition(Vector2D(width / 2 - btSize.x / 2, txtSize.y + 20))
		bt:SetUserData("answerFn", answerYesFn)
		bt:SetUserData("backScreen", backScreen)
	else
		printErrorConsole("Error: dialogType '" .. dialogType .. "' unknown !!")
	end
	
	-- Color rect
	local contentSize = Vector2D(width, txtSize.y + 20 + btSize.y)
	local margin = 20
	local tmp = tmpGroup:CreateShapeRectangle("backRect", Vector2D(-margin, -margin), contentSize + Vector2D(margin, margin) * 2, Color(0, 0, 30, 220), 2, Color(0, 0, 255))
	tmp:SetZpos(-100)
	
	tmpGroup:SetPosition(screenSize / 2 - contentSize / 2)
	
	-- Escape event
	local event = tmpGroup:GetParentScreen():RegisterButtonEvent(function(keyName, isPressed, event)
																	event:GetUserData("answerFn")()
																	ChangeScreen(event:GetUserData("backScreen"))
																	event:GetUserData("group"):Destroy()
																end, "Escape", true)
	if dialogType == "dialogYesNo" then
		event:SetUserData("answerFn", answerNoFn)
	else
		event:SetUserData("answerFn", answerYesFn)
	end
	event:SetUserData("backScreen", backScreen)
	event:SetUserData("group", tmpGroup)
	guiLib_addAutoDestroyEvent(tmpGroup, event)
	
	-- Change
	ChangeScreen(tmpScreen)
end
